// Teil des Projekts "LinADT" -- Lineare abstrakte Datentypen Keller und Schlange
// R. Krell (www.r-krell.de); Javatexte zum Skript "keller-und-schlange_(r-krell).pdf", 22.12.2006

public class ADT_Keller implements ADT_Speicher
// 2. Version: dynam. Implementation mit (rekursiven) Knoten
{
  protected ADT_Knoten kopf; // Verankerung der Struktur

  public ADT_Keller() // hier mit Extra-Konstruktor. Oder zwei Zeilen hher
  {                   // die Variable kopf mit null initialisieren
    kopf = null;
  }                   // legt neuen leeren Keller an

  public boolean istLeer() // sagt, ob der Speicher leer ist
  {                        // genau dann wahr, wenn der Keller leer ist
    return (kopf == null);
  }

  public Object zeige()    // zeigt/kopiert oberstes Element, ohne Keller zu ndern
  {
    return (kopf.holeInhalt());
  }

  public Object raus()     // zeigt oberstes El. und entfernt es aus dem Keller
  {
    Object altesElement = kopf.holeInhalt();
    kopf = kopf.holeNachbarKnoten();
    return (altesElement);
  }

  public void rein (Object neuesElement) // bergebenes Element kommt in Keller
  {
    ADT_Knoten neu = new ADT_Knoten (neuesElement, kopf);
    kopf = neu;
  }
}

