// Teil des Projekts "LinADT" -- Lineare abstrakte Datentypen Keller und Schlange
// R. Krell (www.r-krell.de); Javatexte zum Skript "keller-und-schlange_(r-krell).pdf", 22.12.2006

import java.awt.*;
import java.awt.event.*;

public class ADT_Oberflaeche extends Frame
// Oberflche zum Testen des Kellers bzw. weiterer LinADTs
{
  TextField eingabe = new TextField("",8);
  TextArea ausgabe = new TextArea("Zuerst einen LinADT mit der oberen Tastenreihe whlen!\n",10,95);
  CheckboxGroup cbg = new CheckboxGroup();
  Checkbox cbZahl, cbZchn, cbText;
  Button knKellerReih, knSchlangeReih,
    knKellerDyn, knSchlangeDyn, knWeitere,
    knRein, knRaus, knZeige, knLeer;// Knpfe definieren
  
  ADT_Speicher datenSpeicher; // Definieren eines allgemeinen LinADTs namens datenSpeicher

  public void richteFensterEin() // Fenster initalisieren und beschreiben
  {
    //WindowsListener hinzufgen, damit Schlieknopf funktioniert
    addWindowListener (    
      new WindowAdapter ()
      {
        public void windowClosing (WindowEvent ereignis)
        {                
          setVisible (false);
          dispose();  
          System.exit(0);
        }
      }
    ); // runde Klammer vom Windowlistener geschlossen;  
    
    setTitle("Testprogramm fr lineare abstrakte Datentypen (LinADTs)"); // Fenster mit Titel versehen
    setSize (720,278); // Fenstergre (Breite und Hhe in Pixeln) festlegen
  }  
   
  public void richteRadiobuttonsEin()
  {
    cbZahl = new Checkbox ("Zahl", cbg, false);
    cbZchn = new Checkbox ("Zeichen", cbg, false);
    cbText = new Checkbox ("Text", cbg, true);
  }
  
  public void richteKnpfeEin()
  {     
    // Knpfe erzeugen:
    knKellerReih     = new Button ("Keller (statisch, mit Reihung)");
    knKellerDyn      = new Button ("Keller (dyn., mit Knoten)");
    knSchlangeReih   = new Button ("Schlange (statisch)");
    knSchlangeDyn    = new Button ("Schlange (dynamisch)");
    knWeitere        = new Button ("(unbelegt)");
    knRein           = new Button ("rein");
    knRaus           = new Button ("raus");
    knZeige          = new Button ("zeige");
    knLeer           = new Button ("istLeer ?");
        
    //Funktion der Knpfe festlegen:
    
    knKellerReih.addActionListener (
      new ActionListener () 
      { 
        public void actionPerformed (ActionEvent e) 
        { 
         datenSpeicher = new ADT_Keller1 (); // Erzeugen von datenSpeicher
           // als spezieller Keller mit Reihung
         ausgabe.append ("Ein neuer leerer Keller wurde in/mit einer Reihung erzeugt.\n"); 
         eingabe.requestFocus(); // aktviert die Eingabezeile,  
          // sodass knftige Tastatureingaben automatisch in der eingabe landen  
         eingabe.selectAll(); // macht evtl. Text in der Eingabezeile blau, 
          // sodass alter Text automatisch berschrieben wird 
        } 
      });

    knKellerDyn.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
         datenSpeicher = new ADT_Keller (); // Erzeugen von datenSpeicher
          // als spezieller dynamischer Keller
         ausgabe.append ("Ein neuer leerer Keller wurde dynamisch mit rekursiven Knoten erzeugt.\n");
         eingabe.requestFocus();
         eingabe.selectAll();
        }
      });

    knSchlangeReih.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
//         datenSpeicher = new ADT_Schlange1 (); // Erzeugen von datenSpeicher
//         ausgabe.append ("Eine neue leere Schlange wurde in/mit einer Reihung erzeugt.\n");
         ausgabe.append ("noch ohne Funktion -- letzter gewhlter Datentyp bleibt!\n");
         eingabe.requestFocus(); 
         eingabe.selectAll(); 
        } 
      });  

    knSchlangeDyn.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          datenSpeicher = new ADT_Schlange(); // Erzeugen von datenSpeicher
           // als dynamische Schlange
          ausgabe.append ("Eine neue leere Schlange wurde dynamisch mit rekursiven Knoten erzeugt.\n");
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });    

    knRein.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
           String ein = eingabe.getText();
           String aus = "???";
           Object Obj = null;
           eingabe.requestFocus();
           eingabe.selectAll();
           if (ein.equals(""))
           {
             ausgabe.append ("** Erst Element eingeben, das rein soll! **\n");
           }
           else
           {
             if (cbZahl.getState())
             {
               Obj = new Double (ein);
               aus = "Zahl "+Obj.toString();
             }
             else if (cbZchn.getState())
             {
               Obj = new Character (ein.charAt(0));
               aus = "Zeichen '"+Obj.toString()+"'";
               eingabe.select(0,1);
             }
             else if (cbText.getState())
             {
               Obj = ein;
               aus = "Zeichenkette \""+ein+"\"";
             }
             try
             {
               datenSpeicher.rein (Obj);
               ausgabe.append (""+aus+" gespeichert!\n");
             }
             catch (Exception f)
             {
               ausgabe.append ("** "+f+"\n");
             }
           }
        }       
      });

        
    knRaus.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          Object Obj = null;
          String aus = "???";
          try
          {
            Obj = datenSpeicher.raus();
            if (Obj instanceof Double)
            { 
               aus = "Zahl "+Obj;
            }
            else if (Obj instanceof Character)
            { 
               aus = "Zeichen '"+Obj+"'";
            }
            else if (Obj instanceof String)
            { 
               aus = "Zeichenkette \""+Obj+"\"";
            }
            ausgabe.append (aus+" entfernt!\n");
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  
        
    knZeige.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          Object Obj = null;
          String aus = "???";
          try
          {
            Obj = datenSpeicher.zeige();
            if (Obj instanceof Double)
            { 
               aus = "Zahl "+Obj;
            }
            else if (Obj instanceof Character)
            { 
               aus = "Zeichen '"+Obj+"'";
            }
            else if (Obj instanceof String)
            { 
               aus = "Zeichenkette \""+Obj+"\"";
            }
            ausgabe.append (aus+" ist vorne/oben.\n");
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  

    knLeer.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          // Hier kein try-catch, obwohl auch Fehler NullPointerException entstehen kann,
          // nmlich wenn Knopf gedrckt, bevor Keller erzeugt wurde
          if (datenSpeicher.istLeer())
          {
            ausgabe.append ("Der Speicher ist im Moment leer!\n");
          }
          else
          {
            ausgabe.append ("Der Speicher ist im Moment nicht leer!\n");
          }
        }   
      });  

  } 
   
  public void fhreAus ()
  { 
    richteFensterEin();
    richteRadiobuttonsEin();
    richteKnpfeEin();      
    ausgabe.setEditable(false); // Ausgabe nicht vom Benutzer nderbar
    setLayout (new FlowLayout());

    add (knKellerReih); 
    add (knKellerDyn);
    add (knSchlangeReih);   
    add (knSchlangeDyn);
    add (knWeitere);
    add (eingabe);
    add (new Label(" als"));
    add (cbZahl);
    add (cbZchn);
    add (cbText);
    add (knRein);
    add (new Label(""));
    add (knLeer); add (new Label(""));
    add (knZeige); add (new Label(""));
    add (knRaus); add (new Label(""));
    add (ausgabe);
    setVisible(true);      
  }   
}
