// Teil des Projekts "LinADT" -- Lineare abstrakte Datentypen Keller und Schlange
// R. Krell (www.r-krell.de); Javatexte zum Skript "keller-und-schlange_(r-krell).pdf", 22.12.2006

public class ADT_Schlange extends ADT_Keller
 // implements ADT_Speicher kann entfallen, da durch Keller bereits zugesichert
 // erweitert den Keller zur Schlange (dynamische Implementation mit Knoten)
{
  protected ADT_Knoten schwanz; // kopf existiert schon im und durch den Keller

  public ADT_Schlange ()
  {
    super();        // Keller-Konstruktor aufrufen
    schwanz = null; // zustzlich
  }

  public void rein (Object neuesElement)  // wirkt jetzt am Ende
  {
    ADT_Knoten neu = new ADT_Knoten (neuesElement, null);
    if (istLeer())
    {
      kopf = neu;   //1. Element: auch kopf muss auf den neuen Knoten zeigen
    }               //hierfr darf kopf hchstens 'protected', nicht 'private' sein.
    else
    {
      schwanz.ndereNachbarn(neu);  //sonst: Vorgnger muss auf den neuen Knoten zeigen
    }
    schwanz = neu;  //immer zeigt auch der Schwanz auf den letzten Knoten
  }
}

