// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

public abstract class TADT_StatSpeicherMitEndzugriff<Elementtyp> implements TADT_Speicher<Elementtyp>
// Gemeinsame Oberklasse fr Keller und Schlange mit Reihung -- alternative Typisierung

// Achtung: raus aus einem leeren Speicher liefert keinen (ArrayIndexOutOfBounds-) Fehler,
// sondern -- da Anfang und Ende der Reihung praktisch verbunden sind -- das Element
// an der nchsten (verbundenen) Stelle. Gibt's dort kein Element, wird null geliefert.
// Da dadurch kein Fehler bemerkt wird, wird kopf wie bei einer erfolgreichen raus-Operation
// verndert, sodass danach der Speicher nicht mehr als leer gilt und istLeer false
// liefert. Erst nach Einfgen eines Elements in den Speicher in diesem Zustands gilt dieser
// wieder als leer! Deshalb muss der Aufruf von raus bei leerem Speicher unbedingt vom
// Anwender vermieden werden!

{
  protected final int MAX = 100; // stat. Gre;  MAX-1 = Maximale Zahl der Elemente
  protected Object[] reihung ;
  protected int kopf;
  
  public ADT_StatSpeicherMitEndzugriff()   // Konstruktor fr neuen, leeren Speicher
  {
    reihung = new Object [MAX]; // Anlegen der stat. Reihung (nicht als Elementtyp[MAX] mglich!)
    kopf = MAX-1;               // wegen raus;
  }
  
  public abstract void rein (Elementtyp element); // bergebenes Element kommt in Speicher
   // abtrakte Klasse: Wird von Keller und Schlange verschieden implementiert
   
  public abstract boolean istLeer();          // sagt, ob der Speicher leer ist
   // abtrakte Klasse: Wird von Keller und Schlange verschieden implementiert
   
  public Elementtyp zeige()        // zeigt oberstes Element ohne ndern des Speichers
  {
    return ((Elementtyp)(reihung[kopf]));  // TypeCast ntig, damit Typisierung stimmt. Wird aber gewarnt!
  }
  
  public Elementtyp raus()         // zeigt oberstes El. und lscht es aus dem Speicher
  {
    Elementtyp hilf = (Elementtyp)(reihung[kopf]);   // TypeCast ntig, damit Typisierung stimmt. Wird aber gewarnt!
    kopf = (kopf+MAX-1) % MAX;  // reduziert kopf um 1. Nur nach 0 kommt wieder MAX-1
    return (hilf);
  }
}

